# Thanks to Brian Brazil @ gnewsense
#
-# This version, suited for 2.6.25, avoids removing Free Software for
+# This version, suited for 2.6.23, avoids removing Free Software for
# the sake of removing non-Free Software. Drivers that currently
# require non-Free firmware are retained, but firmware included in
# GPLed sources is replaced with /*(DEBLOBBED)*/ if the deblob-check
# script, that knows how to do this, is present. -lxoliva
+# For each kver release, start extra with an empty string, then count
+# from 1 if changes are needed that require rebuilding the tarball.
+kver=2.6.23 extra=
+
+sed -i "s,^EXTRAVERSION.*,EXTRAVERSION = -libre$extra," Makefile
+
####################
# FOOOOO XXXXXX
# drivers/net/tokenring/Kconfig needs as last line:
rm -v $1
}
+check=`echo $0 | sed 's,/[^/]*$,,'`/deblob-check
function clean_blob {
#$1 = filename
- if test -f $0-check; then
- $0-check -d $1 > $1.deblob
- mv $1.deblob $1
+ if test -f $check; then
+ name=$1
+ set fnord "$@" -d
+ shift 2
+ $check "$@" $name > $name.deblob
+ mv $name.deblob $name
else
clean_file $1
fi
EOF
-clean_blob drivers/net/tg3.c
+clean_blob drivers/net/tg3.c -s 9
sed -i 's:\(\/\*(DEBLOBBED)\*\/\),:\1:' drivers/net/tg3.c
# TYPHOON - 3cr990 series Typhoon
# Thanks to Brian Brazil @ gnewsense
#
-# This version, suited for 2.6.25, avoids removing Free Software for
+# This version, suited for 2.6.24, avoids removing Free Software for
# the sake of removing non-Free Software. Drivers that currently
# require non-Free firmware are retained, but firmware included in
# GPLed sources is replaced with /*(DEBLOBBED)*/ if the deblob-check
# script, that knows how to do this, is present. -lxoliva
+# For each kver release, start extra with an empty string, then count
+# from 1 if changes are needed that require rebuilding the tarball.
+kver=2.6.25 extra=
+
+sed -i "s,^EXTRAVERSION.*,EXTRAVERSION = -libre$extra," Makefile
+
####################
# FOOOOO XXXXXX
# drivers/net/tokenring/Kconfig needs as last line:
rm -v $1
}
+check=`echo $0 | sed 's,/[^/]*$,,'`/deblob-check
function clean_blob {
#$1 = filename
- if test -f $0-check; then
- $0-check -d $1 > $1.deblob
- mv $1.deblob $1
+ if test -f $check; then
+ name=$1
+ set fnord "$@" -d
+ shift 2
+ $check "$@" $name > $name.deblob
+ mv $name.deblob $name
else
clean_file $1
fi
EOF
-clean_blob drivers/net/tg3.c
+clean_blob drivers/net/tg3.c -s 9
sed -i 's:\(\/\*(DEBLOBBED)\*\/\),:\1:' drivers/net/tg3.c
# TYPHOON - 3cr990 series Typhoon
--- /dev/null
+#! /bin/sh
+
+# Copyright (C) 2008 Alexandre Oliva <lxoliva@fsfla.org>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
+# USA
+
+# deblob.sh - prepare a linux-libre tarball out of a non-libre Linux
+# tarball. It expects the Linux release (kver) as the first argument,
+# and the libre sub-release (extra) as the second optional argument.
+
+# linux-$kver.tar.bz2 and deblob-$kver must exist in the current
+# directory, and the line that sets kver and extra in deblob-$kver
+# must match the command-line arguments.
+
+# The resulting tarball is put in linux-$kver-libre$extra.tar.bz2, and
+# an uncompressed xdelta that produces linux-$kver-libre$extra.tar out
+# of linux-$kver.tar is created as linux-$kver-libre$extra.xdelta.
+# This xdelta can be distributed to enable third parties to easily
+# reconstruct the binary tarball starting out of sources downloaded
+# from kernel.org, but without distributing non-Free Software
+# yourself, because xdelta (unlike patches) is not reversible: the
+# removed bits are not present in it at all.
+
+# To enable you to check the differences between the tarballs, a patch
+# file is generated in linux-$kver-libre$extra.patch. This patch file
+# contains the non-Free blobs, even though in reversed form, so its
+# distribution is discouraged.
+
+# At the end, the script attempts to generate a digital signature for
+# the newly-created tarball. This is the last thing the script does,
+# so interrupting it at that point to skip the signing won't fail to
+# do anything else.
+
+# It is safe to interrupt the script at any other point. When it gets
+# a ^C (other than during signing), it starts cleaning up all of its
+# temporary and output files. If you insist, it may leave junk
+# behind, and then it will refuse to run again before you clean it up
+# by hand. It takes extra care to avoid overwriting useful files.
+
+kver=$1 extra=$2 libre=libre$extra
+deblob= dir=`echo $0 | sed 's,/[^/]*$,,'`
+
+if test ! -f linux-$kver.tar.bz2; then
+ echo linux-$kver.tar.bz2 does not exist >&2
+ exit 1
+fi
+
+if test -f deblob-$kver; then
+ deblob=deblob-$kver
+elif test -f deblob; then
+ deblob=deblob
+elif test -f $dir/deblob-$kver; then
+ cp $dir/deblob-$kver deblob
+ deblob=deblob
+else
+ echo deblob does not exist >&2
+ exit 1
+fi
+
+x1="kver=$kver extra=$extra"
+x2=`grep \"^$x1$\" $deblob`
+if test "$x1" != "$x2"; then
+ :
+else
+ echo deblob script does not match command-line arguments >&2
+ echo expected: $x1 >&2
+ echo found : $x2 >&2
+ exit 1
+fi
+
+if test -f linux-$kver-$libre.tar.bz2; then
+ echo linux-$kver-$libre.tar.bz2 already exists >&2
+ exit 1
+fi
+
+if test -f linux-$kver.tar; then
+ echo linux-$kver.tar already exists >&2
+ exit 1
+fi
+
+if test -f linux-$kver-$libre.tar; then
+ echo linux-$kver-$libre.tar already exists >&2
+ exit 1
+fi
+
+if test -f linux-$kver-$libre.patch; then
+ echo linux-$kver-$libre.patch already exists >&2
+ exit 1
+fi
+
+if test -f linux-$kver-$libre.xdelta; then
+ echo linux-$kver-$libre.xdelta already exists >&2
+ exit 1
+fi
+
+if test -d linux-$kver; then
+ echo linux-$kver already exists >&2
+ exit 1
+fi
+
+if test -d linux-$kver-$libre; then
+ echo linux-$kver-$libre already exists >&2
+ exit 1
+fi
+
+if test -d orig-linux-$kver; then
+ echo orig-linux-$kver already exists >&2
+ exit 1
+fi
+
+if test -f $dir/deblob-$kver; then
+ if cmp $dir/deblob-$kver $deblob; then
+ :
+ else
+ echo $dir/deblob-$kver and $deblob are different >&2
+ exit 1
+ fi
+fi
+
+if test ! -f deblob-check; then
+ if test -f $dir/deblob-check; then
+ cp $dir/deblob-check deblob-check
+ fi
+else
+ if test -f $dir/deblob-check; then
+ if cmp $dir/deblob-check deblob-check; then
+ :
+ else
+ echo $dir/deblob-check and deblob-check are different >&2
+ exit 1
+ fi
+ fi
+fi
+
+trap "status=$?; echo cleaning up...; rm -rf orig-linux-$kver linux-$kver linux-$kver-$libre linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.tar.bz2 linux-$kver-$libre.patch linux-$kver-$libre.xdelta; (exit $status); exit" 0 1 2 15
+
+echo Uncompressing linux-$kver.tar.bz2 into linux-$kver.tar
+rm -rf linux-$kver linux-$kver.tar
+bunzip2 < linux-$kver.tar.bz2 > linux-$kver.tar
+
+echo Extracing linux-$kver.tar into linux-$kver
+tar -xf linux-$kver.tar
+rm -rf linux-$kver-$libre linux-$kver-$libre.tar
+
+echo Copying linux-$kver to linux-$kver-$libre.tar
+cp linux-$kver.tar linux-$kver-$libre.tar
+cp -lR linux-$kver/. linux-$kver-$libre
+
+echo Deblobbing within linux-$kver-$libre
+(cd linux-$kver-$libre && /bin/sh ../$deblob)
+rm -f linux-$kver-$libre.patch
+
+echo Generating linux-$kver-$libre.patch
+diff -druN linux-$kver linux-$kver-$libre > linux-$kver-$libre.patch
+
+echo Removing removed or modified files from linux-$kver-$libre.tar
+diff -rq linux-$kver linux-$kver-$libre |
+sed -n "
+ s,^Only in \(linux-$kver/.*\): \(.*\),\1/\2,p;
+ s,^Files \(linux-$kver/.*\) and libre-\1 differ,\1,p;
+" |
+xargs tar --delete -f linux-$kver-$libre.tar
+
+echo Adding modified or added files to linux-$kver-$libre.tar
+rm -rf orig-linux-$kver
+mv linux-$kver orig-linux-$kver
+mv linux-$kver-$libre linux-$kver
+diff -rq orig-linux-$kver linux-$kver |
+sed -n "
+ s,^Files orig-\(linux-$kver/.*\) and \1 differ,\1,p;
+ s,^Only in \(linux-$kver/.*\): \(.*\),\1/\2,p;
+" |
+xargs tar --append -f linux-$kver-$libre.tar
+
+echo Wiping out extracted trees
+rm -rf linux-$kver orig-linux-$kver
+
+echo Creating xdelta between linux-$kver.tar and linux-$kver-$libre.tar
+xdelta delta -0 linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.xdelta
+
+echo Compressing linux-$kver-$libre.tar
+rm -f linux-$kver.tar
+bzip2 -9 linux-$kver-$libre.tar
+
+trap "status=$?; (exit $status); exit" 0 1 2 15
+
+echo Done except for signing, feel free to interrupt
+gpg -a --detach-sign linux-$kver-$libre.tar.bz2
+mv linux-$kver-$libre.tar.bz2.asc linux-$kver-$libre.tar.bz2.sign
+
+echo All set, please review linux-$kver-$libre.patch
+
+exit 0